<?php

defined ('_JEXEC') or die('Restricted access');

class plgVmShipmentEShopLogistic extends vmPSPlugin {

	/**
	 * @param object $subject
	 * @param array  $config
	 */
	function __construct (& $subject, $config) {

		parent::__construct ($subject, $config);

		$this->_loggable = TRUE;
		$this->_tablepkey = 'id';
		$this->_tableId = 'id';
		$this->tableFields = array_keys ($this->getTableSQLFields ());
		$varsToPush = $this->getVarsToPush();
		$this->addVarsToPushCore($varsToPush,0);

		$this->setConfigParameterable ($this->_configTableFieldName, $varsToPush);
		$this->setConvertable(array('min_amount','max_amount','shipment_cost','package_fee'));
		
		require_once(__DIR__.'/class_eshoplogistic.php');
		//vmdebug('Muh constructed plgVmShipmentWeight_countries',$varsToPush);
	}
	
	
	public function onAjaxEShopLogistic(){
		$input = JFactory::getApplication()->input;
		$task = $input->getVar('task');
		
		require_once(JPATH_ROOT.'/administrator/components/com_virtuemart/models/shipmentmethod.php');
		$model = new VirtueMartModelShipmentmethod();
		foreach ($model->getShipments(true) as $plugin_shipment) {
			if ($plugin_shipment->shipment_element == "eshoplogistic") {
				$params = eShopLogistic::parseStr($plugin_shipment->shipment_params);
				break;
			}
		}
		
		if (!isset($params)) {
			exit('ERROR: plugin eshoplogistic not enabled');
		}
		
		switch ($task)
		{
			case 'get_cities':
				$name = $input->getVar('name');
				$country_id = $input->getInt('country_id');
				$country_code = '';
				//$allowed_countries = explode(',', 'RU,UZ,AZ,KZ,BY,UA,TJ,KG,AM,MD');
				
				$eShopLogistic = new eShopLogistic($params);
				$config = $eShopLogistic->get_config();
				if ($country_id) {
					//VirtueMartModelCountry
					$country = VirtueMartModelCountry::getCountry($country_id);
					if (isset($country->country_2_code)/* && in_array($country->country_2_code, $allowed_countries)*/) {
						$country_code = $country->country_2_code;
					}
				}
				if (!empty($country_code)) {
					$cities = $eShopLogistic->search($name, $country_code);
				} else {
					$cities = $eShopLogistic->search($name);
				}
				//var_dump($cities);
				foreach ($cities->data as &$city) {
					$str = array();
					foreach ($city->services as $service => $city_id) {
						$str[] = $service.'='.(int)$city_id;
					}
					$str = implode('|', $str);
					$city->services = $str;
				}
				echo json_encode($cities->data);
				break;
			
			case 'clear_cache':
				$jconfig = JFactory::getConfig();
				$secret = $jconfig->get('secret');
				if ($secret == $input->get('secret')) {
					$cache = JFactory::getCache('plg_vmshipment_eshoplogistic', '');
					$cache->clean();
					echo json_encode(array('status' => 'ok', 'message' => 'cache cleaned'));
				} else {
					echo json_encode(array('status' => 'error', 'message' => 'access denied'));
				}
				break;
		}
		exit;
	}

	/**
	 * Создайте таблицу для этого плагина, если он еще не существует.
	 *
	 */
	public function getVmPluginCreateTableSQL () {

		return $this->createTableSQL ('Shipment Weight Countries Table');
	}

	/**
	 * @return array
	 */
	function getTableSQLFields () {

		$SQLfields = array(
			'id'                           => 'int(1) UNSIGNED NOT NULL AUTO_INCREMENT',
			'virtuemart_order_id'          => 'int(11) UNSIGNED',
			'order_number'                 => 'char(32)',
			'virtuemart_shipmentmethod_id' => 'mediumint(1) UNSIGNED',
			'shipment_name'                => 'varchar(5000)',
			'order_weight'                 => 'decimal(10,4)',
			'shipment_weight_unit'         => 'char(3) DEFAULT \'KG\'',
			'shipment_cost'                => 'decimal(10,2)',
			
			'service'             => 'char(32)',
			'from'                => 'int(11) UNSIGNED',
			'from_name'           => 'varchar(255)',
			'to'                  => 'int(11) UNSIGNED',
			'to_name'             => 'varchar(255)',
			'offers'              => 'text',
			'delivery'              => 'text',
			
			'shipment_package_fee'         => 'decimal(10,2)',
			'tax_id'                       => 'smallint(1)'
		);
		return $SQLfields;
	}

	/**
	 * Это событие запускается после сохранения заказа; оно получает данные, относящиеся к конкретному способу отправки.
	 *
	 * @param int    $order_id The order_id being processed
	 * @param object $cart  the cart
	 * @param array  $order The actual order saved in the DB
	 * @return mixed Null when this method was not selected, otherwise true
	 */
	function plgVmConfirmedOrder (VirtueMartCart $cart, $order) {

		if (!($method = $this->getVmPluginMethod ($order['details']['BT']->virtuemart_shipmentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement ($method->shipment_element)) {
			return FALSE;
		}
		$values['virtuemart_order_id'] = $order['details']['BT']->virtuemart_order_id;
		$values['order_number'] = $order['details']['BT']->order_number;
		$values['virtuemart_shipmentmethod_id'] = $order['details']['BT']->virtuemart_shipmentmethod_id;
		$values['shipment_name'] = $this->renderPluginName ($method);
		$values['order_weight'] = $this->getOrderWeight ($cart, $method->weight_unit);
		$values['shipment_weight_unit'] = $method->weight_unit;
		
		$input = JFactory::getApplication()->input;
		$eShopLogistic = new eShopLogistic($method);
		$config = $eShopLogistic->get_config();
		$service = $_COOKIE['delivery_service_eshoplogistic'];
		$terminal_code = $_COOKIE['eshoplogistic_terminal_code'];
		
		$values['service'] = $service;
		$values['from_name'] = $config->data->settings->city_name;
		$values['from'] = $config->data->services->{$service}->city_code;
		$values['to'] = $_COOKIE['eshoplogistic_city_code'];
		$values['to_name'] = $cart->BT['city'];
		$data_deliveries = $eShopLogistic->get_deliveries($cart, $service, $values['to']);
		$values['offers'] = $data_deliveries->offers;
		$values['delivery'] = $eShopLogistic->get_delivery($data_deliveries, $terminal_code);
		$values['delivery']->service = $service;
		$values['delivery']->service_name = $config->data->services->{$service}->name;
		if (!isset($values['delivery']->code)) {
			$values['delivery']->code = $terminal_code;
		}
		$values['delivery'] = json_encode($values['delivery']);
		//header('Content-type: text/plain');var_dump($values, $terminal_code);exit;

		$costs = $this->getCosts($cart, $method, $cart->cartPrices);
		if(!empty($costs)){
			$values['shipment_cost'] = $method->shipment_cost;
			$values['shipment_package_fee'] = $method->package_fee;
		}
		if(empty($values['shipment_cost'])) $values['shipment_cost'] = 0.0;
		if(empty($values['shipment_package_fee'])) $values['shipment_package_fee'] = 0.0;

		$values['tax_id'] = $method->tax_id;
		$this->storePSPluginInternalData ($values);

		$extra = $this->renderByLayout( 'orderdone', array("method" => $this->_currentMethod, 'order' => $order, 'cart'=>$cart) );
		if(!empty($extra)){
			$cart->orderdoneHtml = $extra;
			// $cart->setCartIntoSession(false,true);
		}
		return TRUE;
	}

	/**
	 * Этот метод срабатывает при отображении деталей заказа в бэкэнде.
	 * В нем отображаются данные, относящиеся к конкретной отправке.
	 * ПРИМЕЧАНИЕ, этот плагин НЕ следует использовать для отображения полей формы, так как он вызывается снаружи
	 * форма! Вместо этого используйте plgVmOnUpdateOrderBE()!
	 *
	 * @param integer $virtuemart_order_id The order ID
	 * @param integer $virtuemart_shipmentmethod_id The order shipment method ID
	 * @return mixed Null for shipments that aren't active, text (HTML) otherwise
	 */
	public function plgVmOnShowOrderBEShipment ($virtuemart_order_id, $virtuemart_shipmentmethod_id) {

		if (!($this->selectedThisByMethodId ($virtuemart_shipmentmethod_id))) {
			return NULL;
		}
		$html = $this->getOrderShipmentHtml ($virtuemart_order_id);
		return $html;
	}

	/**
	 * @param $virtuemart_order_id
	 * @return string
	 */
	function getOrderShipmentHtml ($virtuemart_order_id) {
		$db = JFactory::getDBO ();
		$q = 'SELECT * FROM `' . $this->_tablename . '` '
			. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
		$db->setQuery ($q);
		if (!($shipinfo = $db->loadObject ())) {
			$msg=vmText::sprintf('VMSHIPMENT_ESHOPLOGISTIC_COUNTRIES_NO_ENTRY_FOUND', $virtuemart_order_id);
			vmWarn ($msg);
			vmDebug($msg, $q . " " . $db->getErrorMsg ());
			return '';
		}

		$currency = CurrencyDisplay::getInstance ();
		$tax = ShopFunctions::getTaxByID ($shipinfo->tax_id);
		$taxDisplay = is_array ($tax) ? $tax['calc_value'] . ' ' . $tax['calc_value_mathop'] : $shipinfo->tax_id;
		$taxDisplay = ($taxDisplay == -1) ? vmText::_ ('COM_VIRTUEMART_PRODUCT_TAX_NONE') : $taxDisplay;
		
		$delivery = json_decode($shipinfo->delivery);
		//var_dump($shipinfo);
		$html = '<table class="adminlist table">' . "\n";
		$html .= $this->getHtmlHeaderBE();
		$html .= $this->getHtmlRowBE ('Выбрана доставка', $shipinfo->shipment_name);
		
		if ($delivery->code == 'postrf') {
			$text = 'Почта России<br />';
			$text .= $shipinfo->to_name.'<br />';
			$text .= $delivery->comment ? $delivery->comment.'<br />' : '';
		} else {
			if ($delivery->code == 'door') {
				$text = 'Курьер '.$delivery->service_name.' до адреса<br />';
				$text .= $shipinfo->to_name.'<br />';
				$text .= $delivery->comment ? $delivery->comment.'<br />' : '';
			} elseif (isset($delivery->terminal)) {
				$text = ($delivery->terminal->is_postamat ? 'Постамат' : 'Пункт выдачи').' '.$delivery->service_name.' ['.$delivery->terminal->code.']<br />';
				$text .= $delivery->terminal->address.'<br />';
				$text .= $delivery->terminal->phones.'<br />';
				$text .= $delivery->terminal->workTime.'<br />';
				$text .= $delivery->terminal->note ? $delivery->terminal->note.'<br />' : '';
				//$text .= print_r($delivery, 1).'<br />';
			}
		}
		$html .= $this->getHtmlRowBE ('Способ доставки', $text);
		if ($delivery->time) {
			$html .= $this->getHtmlRowBE ('Срок доставки', $delivery->time);
		}
		$html .= $this->getHtmlRowBE ('ESHOPLOGISTIC_COUNTRIES_WEIGHT', $shipinfo->order_weight . ' ' . ShopFunctions::renderWeightUnit ($shipinfo->shipment_weight_unit));
		$html .= $this->getHtmlRowBE ('ESHOPLOGISTIC_COUNTRIES_COST', $currency->priceDisplay ($shipinfo->shipment_cost));
		$html .= $this->getHtmlRowBE ('ESHOPLOGISTIC_COUNTRIES_PACKAGE_FEE', $currency->priceDisplay ($shipinfo->shipment_package_fee));
		$html .= $this->getHtmlRowBE ('ESHOPLOGISTIC_COUNTRIES_TAX', $taxDisplay);
		$html .= '</table>' . "\n";

		return $html;
	}
	
	
	
	

	/**
	 * Этот метод срабатывает при отображении деталей заказа во внешнем интерфейсе.
	 * В нем отображаются данные, относящиеся к конкретной отправке.
	 *
	 * @param integer $virtuemart_order_id The order ID
	 * @param integer $virtuemart_shipmentmethod_id The selected shipment method id
	 * @param string  $shipment_name Shipment Name
	 * @return mixed Null for shipments that aren't active, text (HTML) otherwise
	 */
	public function plgVmOnShowOrderFEShipment ($virtuemart_order_id, $virtuemart_shipmentmethod_id, &$html) {

		//$this->onShowOrderFE ($virtuemart_order_id, $virtuemart_shipmentmethod_id, $shipment_name);
		if (!($this->selectedThisByMethodId ($virtuemart_shipmentmethod_id))) {
			return NULL;
		}
		$html = $this->getOrderShipmentHtml ($virtuemart_order_id);
	}

	/**
	 * @param \VirtueMartCart $cart
	 * @param int             $method
	 * @param array           $cart_prices
	 * @return bool
	 */
	protected function checkConditions ($cart, $method, $cart_prices) {
		$session = JFactory::getSession();
		JHtml::_('jquery.framework');
		JHtml::script('media/jui/js/chosen.jquery.min.js');
		JHtml::script('plugins/vmshipment/eshoplogistic/js/jquery.cookie.js');
		JHtml::script('plugins/vmshipment/eshoplogistic/js/modal.js');
		JHtml::script('plugins/vmshipment/eshoplogistic/js/script.js');
		JHtml::stylesheet('plugins/vmshipment/eshoplogistic/css/style.css');

		static $result = array();
		
		//var_dump($cart);exit;
		
		
		$eShopLogistic = new eShopLogistic($method);
		$config = $eShopLogistic->get_config();
		
		$city_codes = eShopLogistic::parseStr($_COOKIE['eshoplogistic_city_codes']);
		//var_dump($city_codes);
		$deliveries = array();
		foreach($city_codes as $service => $city_code) {
			$deliveries[$service] = $eShopLogistic->get_deliveries($cart, $service, $city_code);
		}
		
		$deliveries = $eShopLogistic->rebuild_deliveries($deliveries);
		$deliveries['config'] = $config->data;
		
		$session->set('eshoplogistic_deliveries', $deliveries);
		//header('Content-type: text/plain');var_dump($deliveries);exit;
		//$deliveries_all = $eShopLogistic->get_deliveries_all($cart);
		//var_dump($config, $deliveries_all);
		if (!count($deliveries)) {
			return false;
		}
		
		//header('Content-type: text/plain');var_dump($services);exit;

		$address = (($cart->ST == 0) ? $cart->BT : $cart->ST);
		$type = (($cart->ST == 0) ? 'BT' : 'ST');
		if(!is_array($address)) $address = array();
		if(isset($cart_prices['salesPrice'])){
			$hashSalesPrice = $cart_prices['salesPrice'];
		} else {
			$hashSalesPrice = '';
		}


		if(empty($address['virtuemart_country_id'])) $address['virtuemart_country_id'] = 0;

		$hash = $method->virtuemart_shipmentmethod_id.$type.$address['virtuemart_country_id'].'_'.$hashSalesPrice;

		if(isset($result[$hash])){
			return $result[$hash];
		}

		$this->convert ($method);

		$result[$hash] = parent::checkConditions($cart, $method, $cart_prices);

		if(!$result[$hash]) return false;

		$orderWeight = $this->getOrderWeight ($cart, $method->weight_unit);

		$weight_cond = $this->testRange($orderWeight,$method,'weight_start','weight_stop','weight');
		$nbproducts_cond = $this->_nbproductsCond ($cart, $method);

		$allconditions = (int) $weight_cond + (int)$nbproducts_cond;
		if($allconditions === 2){
			$result[$hash] = true;
			return TRUE;
		} else {
			$result[$hash] = false;
			return FALSE;
		}

		$result[$hash] = false;
		return false;
	}
	
	
	/**
	 * делаем расчет цены
	 * @param VirtueMartCart $cart
	 * @param                $method
	 * @param                $cart_prices
	 * @return int
	 */
	function getCosts (VirtueMartCart $cart, $method, $cart_prices) {
		
		if ($method->free_shipment && $cart_prices['salesPrice'] >= $method->free_shipment) {
			return 0.0;
		}
		$method->shipment_cost = 0;
		
		$address = $cart->getST();
		// Получение адреса из корзины
		//$eShopLogistic = new eShopLogistic($method);
		//$config = $eShopLogistic->get_config();
		//$services = $eShopLogistic->search($city);
		//header('Content-type: text/plain');var_dump($services);exit;
		
		//$deliveries_all = $eShopLogistic->get_deliveries_all($cart);
		//var_dump($deliveries);
		$session = JFactory::getSession();
		$deliveries = $session->get('eshoplogistic_deliveries');
		
		
		if (is_array($deliveries) && isset($_COOKIE['eshoplogistic_city_code']) && !empty($_COOKIE['eshoplogistic_city_code'])
			 && isset($_COOKIE['delivery_service_eshoplogistic']) && !empty($_COOKIE['delivery_service_eshoplogistic'])
			 && isset($_COOKIE['delivery_type_eshoplogistic']) && !empty($_COOKIE['delivery_type_eshoplogistic'])) {
			 
			$type = $_COOKIE['delivery_type_eshoplogistic'];
			$service = $_COOKIE['delivery_service_eshoplogistic'];
			if ($type == 'door') {
				if (isset($deliveries[$type][$service]["info"]->price)) {
			 	 	 //var_dump($deliveries[$type][$service]["info"]->price);
					$method->shipment_cost = (float)$deliveries[$type][$service]["info"]->price;
				}
			} elseif ($type == 'terminal') {
				$terminal_code = $_COOKIE['eshoplogistic_terminal_code'];
				//var_dump($terminal_code);exit;
				if (isset($deliveries['terminals_info'][$service]["info"]->price)) {
					//var_dump($deliveries[$type][$service]["info"]);exit;
					$method->shipment_cost = (float)$deliveries['terminals_info'][$service]["info"]->price;
				}
			} elseif ($type == 'postrf') {
				//header('Content-type: text/plain');var_dump($deliveries);exit;
				if (isset($deliveries['terminals_info']['postrf']["info"]->price)) {
					$method->shipment_cost = (float)$deliveries['terminals_info']['postrf']["info"]->price;
				}
			}
		}
		
		if(empty($method->shipment_cost)) $method->shipment_cost = 0.0;
		if(empty($method->package_fee)) $method->package_fee = 0.0;
		
		if ($method->shipment_cost) {
			return $method->shipment_cost + $method->package_fee;
		}
		
		return 0;
	}
	
	
	
	// генерим селектор метода
	function getPluginHtml($plugin, $selectedPlugin, $pluginSalesPrice) {
	    $app = JFactory::getApplication();
		$pluginmethod_id = $this->_idName;
        $pluginName = $this->_psType . '_name';
       	$params = eShopLogistic::parseStr($plugin->shipment_params);
        
        if ($selectedPlugin == $plugin->$pluginmethod_id) {
            $checked = 'checked="checked"';
        } else {
            $checked = '';
        }
        
        if (!class_exists('CurrencyDisplay')) {
        	require(JPATH_VM_ADMINISTRATOR . DS . 'helpers' . DS . 'currencydisplay.php');
        }
        $currency = CurrencyDisplay::getInstance();
        
		$costDisplay = "";
		if ($pluginSalesPrice) {
        	$costDisplay = ' ('.$currency->priceDisplay($pluginSalesPrice).')';
        }
        
        $plugin_title = $plugin->name;
        if (isset($params->shipment_name_list) && !empty($params->shipment_name_list)) {
        	$plugin_title = eShopLogistic::normalize_utf($params->shipment_name_list);
        }
        
        $package_fee = '';
        if ($plugin->package_fee) {
        	$package_fee = '<br />('.JText::_('VMSHIPMENT_ESHOPLOGISTIC_COUNTRIES_PACKAGE_FEE_ADD').' '.$currency->priceDisplay($plugin->package_fee).')';
        }
        $html = '<div class="vm-shipment-plugin-single">
        	<input type="radio" data-dynamic-update="1" name="'.$pluginmethod_id.'" id="shipment_id_'.$plugin->$pluginmethod_id.'" value="'.$plugin->$pluginmethod_id.'" '.$checked.' class="radio_virtuemart_shipmentmethod_eshoplogistic" />
			<label for="shipment_id_'.$plugin->$pluginmethod_id.'">
				<span class="vmshipment">
					<span class="vmshipment_name">'.$plugin_title . $package_fee.'</span>
					' . /*<span class="vmshipment_cost fee">'.$costDisplay.'</span>*/ '
				</span>
			</label>
		</div>';
		
        if ($selectedPlugin == $plugin->$pluginmethod_id) {
			$eShopLogistic = new eShopLogistic($params);
			$config = $eShopLogistic->get_config();
			
			
			$session = JFactory::getSession();
			$deliveries = array();
			$delivery_cities = array();
			//$html .= print_r($config, 1);
			//$html .= print_r($services, 1);header('Content-type: text/plain');echo $html; exit;
			//$html .= $_COOKIE['eshoplogistic_city'];
			
			//$html .= $_COOKIE['eshoplogistic_city'].' '.$_COOKIE['eshoplogistic_city_code'];
			$deliveries = $session->get('eshoplogistic_deliveries');
			
			$selected_service = null;
			$html_door = '';
			$html_terminal = '';
			$html .= '<div id="delivery_type_eshoplogistic" class="clearfix">';
			//header('Content-type: text/plain');var_dump($deliveries);exit;
			if (isset($deliveries['door']) && count($deliveries['door'])) {
				$html .= '<label for="delivery_type_eshoplogistic_door" class="delivery_type" id="service_eshoplogistic_door_block" data-type="door">
					<input type="radio" name="delivery_type_eshoplogistic" id="delivery_type_eshoplogistic_door" value="door" '.
					($_COOKIE['delivery_type_eshoplogistic'] == 'door' ? 'checked="checked"' : '').' />
					Курьер до адреса
				</label>';
				$html_door = '<div id="delivery_door_eshoplogistic" class="clearfix '.($_COOKIE['delivery_type_eshoplogistic'] == 'door' ? 'active' : '').'">';
				foreach ($deliveries['door'] as $service => $delivery) {
					$html_door .= '<div id="delivery_'.$service.'_door_eshoplogistic" class="delivery_door_item_eshoplogistic'
					.($_COOKIE['delivery_type_eshoplogistic'] == 'door' && $_COOKIE['delivery_service_eshoplogistic'] == $service ? ' active' : '').
					'" data-service="'.$service.'">';
					$html_door .= '<span><img src="'.$deliveries['config']->services->{$service}->logo.'" /></span>';
					$html_door .= '<span>';
					if ($delivery['info']->price > 0) {
						$price_html = $currency->priceDisplay($delivery['info']->price);
					} else {
						$price_html = 'бесплатно';
					}
					$html_door .= $price_html.'<br />'.$delivery['info']->time;
					if (!empty($delivery['info']->comment)) {
						$html_door .= '<br />'.$delivery['info']->comment;
					}
					$html_door .= '</span>';
					$html_door .= '</div>';
				}
				$html_door .= '</div>';
			}
			if (isset($deliveries['all_terminals']) && count($deliveries['all_terminals'])) {
				$html .= '<label for="delivery_type_eshoplogistic_terminal" class="delivery_type" id="service_eshoplogistic_terminal_block" data-type="terminal">
					<input type="radio" name="delivery_type_eshoplogistic" id="delivery_type_eshoplogistic_terminal" value="terminal" '.
					($_COOKIE['delivery_type_eshoplogistic'] == 'terminal' ? 'checked="checked"' : '').' />
					До пункта самовывоза
				</label>';
				$html_terminal = '<div id="delivery_terminal_eshoplogistic" class="clearfix '.($_COOKIE['delivery_type_eshoplogistic'] == 'terminal' ? 'active' : '').'"><a href="#" id="open_map_terminals">Выбрать Пункт самовывоза</a>';
				$html_terminal .= '<script>json_terminals_eshoplogistic = '.json_encode($deliveries['all_terminals']).';
				json_terminals_info_eshoplogistic = '.json_encode($deliveries['terminals_info']).';</script>';
				$html_terminal .= '<div id="delivery_terminal_eshoplogistic_selected">'.$_COOKIE['eshoplogistic_terminal_desc'].'</div>';
				$html_terminal .= '</div>';
			}
			//var_dump($deliveries['terminals_info']['postrf']['info']);
			if (isset($config->data->services->postrf) && is_object($config->data->services->postrf) && isset($deliveries['terminals_info']['postrf']['info'])) {
				$html .= '<label for="delivery_type_eshoplogistic_postrf" class="delivery_type" id="service_eshoplogistic_postrf_block" data-type="postrf">
					<input type="radio" name="delivery_type_eshoplogistic" id="delivery_type_eshoplogistic_postrf" value="postrf" '.
					($_COOKIE['delivery_type_eshoplogistic'] == 'postrf' ? 'checked="checked"' : '').' />
					Почта России
				</label>';
				$html_postrf = '<div id="delivery_postrf_eshoplogistic" class="clearfix '.($_COOKIE['delivery_type_eshoplogistic'] == 'postrf' ? 'active' : '').'">';
				$html_postrf .= '<div class="delivery_postrf_item_eshoplogistic active" data-service="postrf">';
				$html_postrf .= '<span><img src="'.$deliveries['config']->services->postrf->logo.'" /></span>';
				$note = $deliveries['terminals_info']['postrf']['info']->comment ? $deliveries['terminals_info']['postrf']['info']->comment : 'Доставка в ближайшее отделение Почты России';
				$html_postrf .= '<span>'.$currency->priceDisplay($deliveries['terminals_info']['postrf']['info']->price).'<br />'.$note.'</span>';
				$html_postrf .= '</div>';
				$html_postrf .= '</div>';
			}
			
			
			$html .= '</div>';
			$html .= $html_door;
			$html .= $html_terminal;
			$html .= $html_postrf;
			//$html .= print_r($delivery_cities, 1);
			
			//$eShopLogistic = new eShopLogistic($method);
			//$html .= print_r($plugin->shipment_params, 1);
			//$html .= print_r($method, 1);
        }
        return $html;
  }// function getPluginHtml END

	/**
	 * @param $method
	 */
	function convert (&$method) {

		//$method->weight_start = (float) $method->weight_start;
		//$method->weight_stop = (float) $method->weight_stop;
		$method->min_amount =  (float)str_replace(',','.',$method->min_amount);
		$method->max_amount =   (float)str_replace(',','.',$method->max_amount);
		$method->nbproducts_start = (int)$method->nbproducts_start;
		$method->nbproducts_stop = (int)$method->nbproducts_stop;
		$method->free_shipment = (float)str_replace(',','.',$method->free_shipment);
	}

	/**
	 * @param $cart
	 * @param $method
	 * @return bool
	 */
	private function _nbproductsCond ($cart, $method) {

		if (empty($method->nbproducts_start) and empty($method->nbproducts_stop)) {
			//vmdebug('_nbproductsCond',$method);
			return true;
		}

		$nbproducts = 0;
		foreach ($cart->products as $product) {
			$nbproducts += $product->quantity;
		}

		if ($nbproducts) {

			$nbproducts_cond = $this->testRange($nbproducts,$method,'nbproducts_start','nbproducts_stop','products quantity');

		} else {
			$nbproducts_cond = false;
		}

		return $nbproducts_cond;
	}


	private function testRange($value, $method, $floor, $ceiling,$name){

		$cond = true;
		if(!empty($method->$floor) and !empty($method->$ceiling)){
			$cond = (($value >= $method->$floor AND $value <= $method->$ceiling));
			if(!$cond){
				$result = 'FALSE';
				$reason = 'is NOT within Range of the condition from '.$method->$floor.' to '.$method->$ceiling;
			} else {
				$result = 'TRUE';
				$reason = 'is within Range of the condition from '.$method->$floor.' to '.$method->$ceiling;
			}
		} else if(!empty($method->$floor)){
			$cond = ($value >= $method->$floor);
			if(!$cond){
				$result = 'FALSE';
				$reason = 'is not at least '.$method->$floor;
			} else {
				$result = 'TRUE';
				$reason = 'is over min limit '.$method->$floor;
			}
		} else if(!empty($method->$ceiling)){
			$cond = ($value <= $method->$ceiling);
			if(!$cond){
				$result = 'FALSE';
				$reason = 'is over '.$method->$ceiling;
			} else {
				$result = 'TRUE';
				$reason = 'is lower than the set '.$method->$ceiling;
			}
		} else {
			$result = 'TRUE';
			$reason = 'no boundary conditions set';
		}

		if(!$result) vmdebug('shipmentmethod '.$method->shipment_name.' = '.$result.' for variable '.$name.' = '.$value.' Reason: '.$reason);
		return $cond;
	}


	/**
	 * Создайте таблицу для этого плагина, если он еще не существует.
	 * Эта функция проверяет, является ли вызываемый плагин активным.
	 * Если да, то вызывается стандартный метод для создания таблиц
	 *
	 */
	function plgVmOnStoreInstallShipmentPluginTable ($jplugin_id) {

		return $this->onStoreInstallPluginTable ($jplugin_id);
	}

	/**
	 * plgVmDisplayListFE
	 * Это событие запускается для отображения методов подключения в корзине (редактирование отправки / оплаты), например
	 *
	 * @param object  $cart Cart object
	 * @param integer $selected ID of the method selected
	 * @return boolean True on success, false on failures, null when this plugin was not selected.
	 * On errors, JError::raiseWarning (or JError::raiseError) must be used to set a message.
	 */
	public function plgVmDisplayListFEShipment (VirtueMartCart $cart, $selected = 0, &$htmlIn) {
		return $this->displayListFE ($cart, $selected, $htmlIn);
	}

	/**
	 * @param VirtueMartCart $cart
	 * @param array          $cart_prices
	 * @param                $cart_prices_name
	 * @return bool|null
	 */
	public function plgVmOnSelectedCalculatePriceShipment (VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {

		return $this->onSelectedCalculatePrice ($cart, $cart_prices, $cart_prices_name);
	}

	/**
	 * plgVmOnCheckAutomaticSelected
	 * Проверяет, сколько плагинов доступно. Если только один, то у пользователя не будет выбора. Введите страницу edit_xxx
	 * Плагин должен сначала проверить, правильный ли он тип
	 *
	 * @param VirtueMartCart cart: the cart object
	 * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
	 *
	 */
	function plgVmOnCheckAutomaticSelectedShipment (VirtueMartCart $cart, array $cart_prices, &$shipCounter) {
		return $this->onCheckAutomaticSelected ($cart, $cart_prices, $shipCounter);
	}

	/**
	 * @param VirtueMartCart $cart
	 * @return null
	 */
	public function plgVmOnSelectCheckShipment (VirtueMartCart &$cart) {
		
		$result = $this->OnSelectCheck ($cart);
		return $result;
	}
	
	
	function plgVmOnCheckoutCheckDataShipment(VirtueMartCart $cart){
		
		if(empty($cart->virtuemart_shipmentmethod_id)) return false;

		if ($this->getPluginMethods($cart->vendorId) === 0) {
			return NULL;
		}

		foreach ($this->methods as $this->_currentMethod) {
			if($cart->virtuemart_shipmentmethod_id == $this->_currentMethod->virtuemart_shipmentmethod_id){
				if(!$this->checkConditions($cart, $this->_currentMethod, $cart->cartPrices)){
					return false;
				}
				
				// проверяем заполнены ли поля
				if (empty($_COOKIE['delivery_service_eshoplogistic'])
					|| empty($_COOKIE['eshoplogistic_terminal_code'])
					|| empty($_COOKIE['eshoplogistic_city_code'])) {
						//var_dump($cart);exit;
					return false;
				}
				break;
			}
		}
		
		return true;
	}

	/**
	 * Этот метод срабатывает при отображении при печати заказа
	 * В нем отображаются данные, относящиеся к конкретному способу оплаты.
	 *
	 * @param integer $_virtuemart_order_id The order ID
	 * @param integer $method_id  method used for this order
	 * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
	 */
	function plgVmonShowOrderPrint ($order_number, $method_id) {
		return $this->onShowOrderPrint ($order_number, $method_id);
	}

	function plgVmDeclarePluginParamsShipment ($name, $id, &$dataOld) {
		return $this->declarePluginParams ('shipment', $name, $id, $dataOld);
	}

	function plgVmDeclarePluginParamsShipmentVM3 (&$data) {
		return $this->declarePluginParams ('shipment', $data);
	}


	/**
	 * @param $data
	 * @param $table
	 * @return bool
	 */
	function plgVmSetOnTablePluginShipment(&$data,&$table){

		$name = $data['shipment_element'];
		$id = $data['shipment_jplugin_id'];

		if (!empty($this->_psType) and !$this->selectedThis ($this->_psType, $name, $id)) {
			return FALSE;
		} else {
			$tCon = array('weight_start','weight_stop','min_amount','max_amount','shipment_cost','package_fee');
			foreach($tCon as $f){
				if(!empty($data[$f])){
					$data[$f] = str_replace(array(',',' '),array('.',''),$data[$f]);
				}
			}

			$data['nbproducts_start'] = (int) $data['nbproducts_start'];
			$data['nbproducts_stop'] = (int) $data['nbproducts_stop'];

			//Reasonable tests:
			if(!empty($data['weight_start']) and !empty($data['weight_stop']) and (float)$data['weight_start']>=(float)$data['weight_stop']){
				vmWarn('VMSHIPMENT_ESHOPLOGISTIC_COUNTRIES_WEIGHT_CONDITION_WRONG');
			}

			if(!empty($data['min_order']) and !empty($data['max_order']) and (float)$data['min_order']>=(float)$data['max_order']){
				vmWarn('VMSHIPMENT_ESHOPLOGISTIC_COUNTRIES_AMOUNT_CONDITION_WRONG');
			}

			if(!empty($data['nbproducts_start']) and !empty($data['nbproducts_stop']) and (float)$data['nbproducts_start']>=(float)$data['nbproducts_stop']){
				vmWarn('VMSHIPMENT_ESHOPLOGISTIC_COUNTRIES_NBPRODUCTS_CONDITION_WRONG');
			}

			return $this->setOnTablePluginParams ($name, $id, $table);
		}
	}


}

// No closing tag
