
jQuery(document).ready(function($){
	
	let ID_MODAL = 'esl_yandex_map',
		ID_MODAL_BG = 'esl_yandex_map_bg',
		YANDEX_MAP_CONTAINER_ID = 'esl_yandex_map_container',
		YANDEX_MAP_CONTAINER_ID_FOR_MAP = 'esl-modal-yandex-map-wrap',
		YANDEX_MAP_CONTAINER_ID_FOR_ADDRESS = 'esl-modal-yandex-map-address';


	let modal = {
		backdrop: null,
		initLayout: {
		  createRoot: function (){
			  let root = document.createElement('div');
			  root.setAttribute('tabindex','-1');
			  root.setAttribute('role','dialog');
			  root.setAttribute('id', ID_MODAL);
			  document.body.appendChild(root);
			  return root;
		  },
		  createDialog: function (dom){
			  let dialog = document.createElement('div');
			  dialog.classList.add('modal-dialog','modal-lg');
			  if(document.documentElement.clientWidth < 768){
				  dialog.setAttribute('style','width: 100%');
			  }
			  dom.appendChild(dialog);
			  return dialog;
		  },
		  createContent: function (dom){
			  let content = document.createElement('div');
			  content.classList.add('modal-content');
			  dom.appendChild(content);
			  return content;
		  },
		  createHeader: function (dom){
			  let header = document.createElement('div');
			  header.classList.add('modal-header');
			  header.innerHTML = '<h4>Пункты самовывоза</h4>';
			  dom.appendChild(header);
			  return header;
		  },
		  createButtonClose: function (dom){
			  let buttonClose = document.createElement('button');
			  buttonClose.setAttribute('type','button');
			  buttonClose.setAttribute('data-dismiss','modal');
			  buttonClose.setAttribute('aria-label','Close');
			  buttonClose.classList.add('close');
			  buttonClose.addEventListener('click', modal.close);
			  dom.appendChild(buttonClose);
			  return buttonClose;
		  },
		  createIconClose: function (dom){
			  let iconClose = document.createElement('span');
			  iconClose.setAttribute('aria-hidden','true');
			  iconClose.innerHTML= '&times;';
			  dom.appendChild(iconClose);
			  return iconClose;
		  },
		  createBody: function (dom){
			  let body = document.createElement('div');
			  body.classList.add('modal-body');
			  dom.appendChild(body);
			  return body;
		  },
		  createRow: function (dom){
			  let row = document.createElement('div');
			  /*row.classList.add('class','row');*/
			  dom.appendChild(row);
			  return row;
		  },
		  createColForMap: function (dom){
			  let col = document.createElement('div');
			  /*col.classList.add('col-lg-12','col-md-12');*/
			  col.setAttribute('id',YANDEX_MAP_CONTAINER_ID_FOR_MAP);
			  dom.appendChild(col);
			  return
		  },
			createBackDrop: function (){
				let backdrop = document.createElement('div');
			  	backdrop.setAttribute('id', ID_MODAL_BG);
				backdrop.setAttribute('style', 'display: none');
				backdrop.addEventListener('click', modal.close);
				document.body.appendChild(backdrop);
				modal.backdrop = backdrop;
			},
		},
		createModalBootstrap: function (){
			if(this.checkOnInit()) return;
			let root = this.initLayout.createRoot(),
				dialog = this.initLayout.createDialog(root),
				content = this.initLayout.createContent(dialog),
				header = this.initLayout.createHeader(content),
				buttonClose = this.initLayout.createButtonClose(header),
				iconClose = this.initLayout.createIconClose(buttonClose),
				body = this.initLayout.createBody(content),
				row = this.initLayout.createRow(body),
				colMap = this.initLayout.createColForMap(row);

			this.initLayout.createBackDrop();
		},
		checkOnInit: function (){
			if(document.getElementById(ID_MODAL)){
				return true;
			}
			return false;
		},

		open: function (){
			let modalLocal = document.getElementById(ID_MODAL);
			document.body.setAttribute('style','padding-right:17px');
			modal.backdrop.removeAttribute('style');

			setTimeout(() => {
				modalLocal.setAttribute('style','display:block;padding-left:17px');
				setTimeout(() => {
					modalLocal.classList.add('show');
					modal.backdrop.classList.add('show');
				},200)
			},100)

		},
		close: function (){
			let modalLocal = document.getElementById(ID_MODAL);

			modalLocal.classList.remove('show');
			setTimeout(() => {
				modal.backdrop.classList.remove('show');
				setTimeout(() => {
					document.body.removeAttribute('style');
					modal.backdrop.setAttribute('style', 'display: none');
					modalLocal.removeAttribute('style');
					
					document.getElementById(ID_MODAL).remove();
					document.getElementById(ID_MODAL_BG).remove();
				},200);
			},300);
		}
	}


	let yandexMaps = {
		terminals: [],
		settings: {},
		initApi: function (){
			let script = document.createElement('script');
			script.setAttribute('src', 'https://api-maps.yandex.ru/2.1/?lang=ru_RU');
			script.setAttribute('defer','');
			document.head.appendChild(script);
		},
		createContainer: function (){
			let container = document.createElement('div'),
				modalBody = document.getElementById(ID_MODAL).querySelector('.modal-body  #'+YANDEX_MAP_CONTAINER_ID_FOR_MAP);
			container.setAttribute('id',YANDEX_MAP_CONTAINER_ID);
			container.setAttribute('style','width: 100%;height:400px');
			modalBody.appendChild(container);
		},
		initMap: function (event){
			var map = new ymaps.Map(YANDEX_MAP_CONTAINER_ID, {
				center: [yandexMaps.terminals[0]['lat'],yandexMaps.terminals[0]['lon']],
				zoom: 10,
				controls: ['zoomControl']
			}, {
				suppressMapOpenBlock: true
			})
			map.behaviors.disable('scrollZoom')
			yandexMaps.createPlacemarks(yandexMaps.terminals, map);
		},
		createPlacemarks: function (items, map){
			let geoObjects = [],
				iteration = 0;
			for(const terminal of items){
				if(terminal.lat === '' || terminal.lon === ''){
					continue;
				}
				/*const BalloonContentLayout = ymaps.templateLayoutFactory.createClass(
					`<div style="display: flex;"><div style="padding-right: 15px;" class="img"><img src="{{ properties.image }}"></div><div><h3 style="font-size: 1.3em;font-weight: bold;margin-bottom: 0.5em;">{{ properties.address }}</h3><p>{{ properties.note }}</p><p>Время работы: {{ properties.timeWork }}</p><p><b>Цена доставки: {{ properties.price }}</b></p><button type="button" data-accept-terminal class="btn btn-success">Забрать отсюда</button></div>`,
					{
						build: function (){
							BalloonContentLayout.superclass.build.call(this);
							const button =  document.getElementById(YANDEX_MAP_CONTAINER_ID_FOR_MAP).querySelector('[data-accept-terminal]');
							if(button){
								button.addEventListener('click', this.selectedTerminal);
							}

						},
						clear: function(){
							const button =  document.getElementById(YANDEX_MAP_CONTAINER_ID_FOR_MAP).querySelector('[data-accept-terminal]');
							if(button){
								button.removeEventListener('click', this.selectedTerminal);
							}
							BalloonContentLayout.superclass.clear.call(this);
						},
						selectedTerminal: function (){
							//document.dispatchEvent(new CustomEvent('onSelectAddress', {detail: terminal}));
							$.cookie('eshoplogistic_terminal_code', terminal.code);
							$.cookie('delivery_service_eshoplogistic', terminal.service);
							$.cookie('eshoplogistic_city_code', eshoplogistic_get_city_code(terminal.service));
							
							eshoplogistic_terminal_desc = '<span><img src="'+terminal.image+'" /></span><span>'+$.cookie('eshoplogistic_city_full')+'<br />'+terminal.address+'<br />'+terminal.phones+'<br />'+terminal.workTime+'<br />'+terminal.note+'</span>';
							$.cookie('eshoplogistic_terminal_desc', eshoplogistic_terminal_desc);
							$('#delivery_terminal_eshoplogistic_selected').html(eshoplogistic_terminal_desc);
							
							$(':radio.radio_virtuemart_shipmentmethod_eshoplogistic').click();
							modal.close();
						}
					}
				);*/
				
				balloonContentBody = '<div style="display: flex;" class="balloonContentBody">\
					<div style="padding-right: 15px;" class="img">\
						<img src="'+terminal.image+'">\
					</div>\
					<div>\
						<h3 style="font-size: 1.3em;font-weight: bold;margin-bottom: 0.5em;">\
							'+terminal.address+'\
						</h3>\
						<p><b>Время доставки: '+json_terminals_info_eshoplogistic[terminal.service].info.time+'</b></p>\
						<p><b>Цена доставки: '+json_terminals_info_eshoplogistic[terminal.service].info.price+'</b></p>';
				if (terminal.workTime) {
					balloonContentBody += '<p>Время работы: '+terminal.workTime+'</p>';
				}
				if (terminal.phones) {
					balloonContentBody += '<p>Телефоны: '+terminal.phones+'</p>';
				}
				balloonContentBody += '<p><span class="note">'+terminal.note+'</span></p>\
				<p><button type="button" data-accept-terminal class="btn btn-success" data-code="'+terminal.code+'" data-service="'+terminal.service+'" data-address="'+terminal.address+'" data-phones="'+terminal.phones+'" data-workTime="'+terminal.workTime+'" data-image="'+terminal.image+'" data-note="'+terminal.note+'" data-price="'+json_terminals_info_eshoplogistic[terminal.service].info.price+'" data-time="'+json_terminals_info_eshoplogistic[terminal.service].info.time+'">Забрать отсюда</button></p></div>';
				
				geoObjects[iteration] = new ymaps.Placemark([terminal.lat, terminal.lon],{
					/*image: terminal.image,
					note: terminal.note,
					address: terminal.address,
					timeWork: terminal.workTime ? terminal.workTime : 'Не указано',
					price: json_terminals_info_eshoplogistic[terminal.service].info.price,*/
					clusterCaption: '<img src="'+terminal.image+'" width="36" height="36" />',
					balloonContentBody: balloonContentBody,
				},{
					iconLayout: 'default#image',
					iconImageHref: terminal.image,
					iconImageSize: [40, 43],
					iconImageOffset: [-10, -31],
					//balloonContentLayout: BalloonContentLayout,
					//balloonPanelMaxMapArea: 0
				});
				iteration++;
			}
			let myClusterer = new ymaps.Clusterer(
				{clusterDisableClickZoom: false}
			);
			myClusterer.add(geoObjects);
			map.geoObjects.add(myClusterer);

		},
		destroyMap: function (){
			document.getElementById(YANDEX_MAP_CONTAINER_ID).remove();
		}
	}
	yandexMaps.initApi();
	
	$(document).on('click', '#open_map_terminals', function(e){
		modal.createModalBootstrap();
		e.preventDefault();
		if(json_terminals_eshoplogistic){
			yandexMaps.createContainer();
			yandexMaps.terminals = json_terminals_eshoplogistic;
			ymaps.ready(yandexMaps.initMap);
			modal.open();
		}
	});
	
	$(document).on('click', 'ymaps div.balloonContentBody button', function(){
		button = $(this);
		div = button.closest('div.balloonContentBody');
		
		$.cookie('eshoplogistic_terminal_code', button.data('code'));
		$.cookie('delivery_service_eshoplogistic', button.data('service'));
		$.cookie('eshoplogistic_city_code', eshoplogistic_get_city_code(button.data('service')));
		
		terminal = {
			service: button.data('service'),
			image: button.data('image'),
			time: button.data('time'),
			price: button.data('price'),
			address: button.data('address')
		};
		eshoplogistic_terminal_desc = generate_delivery_terminal_item_eshoplogistic(terminal);
		
		$.cookie('eshoplogistic_terminal_desc', eshoplogistic_terminal_desc);
		$('#delivery_terminal_eshoplogistic_selected').html(eshoplogistic_terminal_desc);
		
		$(':radio.radio_virtuemart_shipmentmethod_eshoplogistic').click();
		modal.close();
	});
	
});
