

function generate_delivery_terminal_item_eshoplogistic(terminal){
	eshoplogistic_terminal_desc = '<div class="delivery_terminal_item_eshoplogistic active">\
		<span>\
			<span class="flex">\
				<span><img src="'+json_terminals_info_eshoplogistic[terminal.service].info.logo+'"></span>\
				<span class="price_time">\
					'+json_terminals_info_eshoplogistic[terminal.service].info.price+'<br>\
					'+json_terminals_info_eshoplogistic[terminal.service].info.time+'\
				</span>\
			</span>\
			<span class="address">\
				'+jQuery.cookie('eshoplogistic_city_full')+'<br />\
				'+terminal.address+'\
			</span>\
		</span>\
	</div>';
	return eshoplogistic_terminal_desc;
}


jQuery(document).ready(function($){
	
	let int_city_field;
	
	$(document).on('keyup', '#city_field', function(){
		this_id_name = $(this).attr('id');
		$('#services_eshoplogistic .service').removeClass('active');
		$('#services_eshoplogistic input:radio').removeAttr('checked');
		clearTimeout(int_city_field);
		
		if (!$('#result_cities_eshoplogistic').length) {
			$('#' + this_id_name).after('<div id="result_cities_eshoplogistic" />');
		}
		$('#result_cities_eshoplogistic').html('');
		
		int_city_field = setTimeout(function(value){
			if (value.length > 2) {
				data = {name: value};
				if ($('#virtuemart_country_id_field').length && $('#virtuemart_country_id_field').val()) {
					data.country_id = $('#virtuemart_country_id_field').val();
				}
				$.post('/index.php?option=com_ajax&plugin=eshoplogistic&group=vmshipment&task=get_cities&format=json', data, function(json){
					container = $('<div class="container_cities" />');
					container.appendTo('#result_cities_eshoplogistic');
					if (json.length) {
						$(json).each(function(){
							container.append('<a href="#" data-city="' + this.name + '" data-city_codes="' + this.services + '" data-region="' + this.region + '" data-fias="' + this.fias + '">' + this.type + ' ' + this.name + (this.region ? ', '+this.region : '') + '</a>');
						});
					} else {
						container.append('<div style="padding: 10px">По поиску "' + value + '" ничего не найдено</div>');
					}
					
				}, 'json');
			}
		}, 500, this.value);
	});
	
	$(document).mouseup(function (e){ // событие клика по веб-документу
		var div = $("#result_cities_eshoplogistic"); // тут указываем ID элемента
		if (!div.is(e.target) // если клик был не по нашему блоку
		    && div.has(e.target).length === 0) { // и не по его дочерним элементам
			div.empty();
		}
	});
	
	$(document).on('click', '#result_cities_eshoplogistic a', function(e){
		e.preventDefault();
		$full_name = $(this).text();
		$.cookie('eshoplogistic_city_full', $full_name);
		$.cookie('eshoplogistic_city_codes', $(this).data('city_codes'));
		$.cookie('eshoplogistic_city', $(this).data('city'));
		$.cookie('eshoplogistic_region', $(this).data('region'));
		$.cookie('delivery_type_eshoplogistic', '');
		$.cookie('delivery_service_eshoplogistic', '');
		$.cookie('eshoplogistic_terminal_code', '');
		$.cookie('eshoplogistic_terminal_desc', '');
		$("#result_cities_eshoplogistic").empty();
		
		$('#city_field').val($(this).data('city'));
		
		$('#virtuemart_state_id_field').trigger('change');
		setTimeout(() => {
			$(':radio.radio_virtuemart_shipmentmethod_eshoplogistic').trigger('click');
		}, 300);
	});
	
	$('body').on('updateVirtueMartCartModule', function(){
		//console.log('updateVirtueMartCartModule');
		
		$.cookie('delivery_type_eshoplogistic', '');
		$.cookie('delivery_service_eshoplogistic', '');
		$.cookie('eshoplogistic_terminal_code', '');
		$.cookie('eshoplogistic_terminal_desc', '');
	});
	
	$('#virtuemart_country_id_field').change(function(){
		$.cookie('eshoplogistic_city_full', '');
		$.cookie('eshoplogistic_city_codes', '');
		$.cookie('eshoplogistic_city', '');
		$.cookie('eshoplogistic_region', '');
		$.cookie('delivery_type_eshoplogistic', '');
		$.cookie('delivery_service_eshoplogistic', '');
		$.cookie('eshoplogistic_terminal_code', '');
		$.cookie('eshoplogistic_terminal_desc', '');
		$('#city_field').val('');
	});
	
	
	
	$(document).on('change', 'input:radio[name=delivery_type_eshoplogistic]', function(){
		$.cookie('delivery_type_eshoplogistic', $(this).val());
		$.cookie('delivery_service_eshoplogistic', '');
		$.cookie('eshoplogistic_terminal_code', '');
		$.cookie('eshoplogistic_terminal_desc', '');
		
		$('#delivery_terminal_eshoplogistic_selected').html('');
		$('div.delivery_door_item_eshoplogistic').removeClass('active');
		
		if ($(this).val() == 'door') {
			$('#delivery_door_eshoplogistic').addClass('active');
			$('#delivery_terminal_eshoplogistic, #delivery_postrf_eshoplogistic').removeClass('active');
			$('#delivery_door_eshoplogistic .delivery_door_item_eshoplogistic:first').trigger('click');
		} else if ($(this).val() == 'terminal') {
			$('#delivery_terminal_eshoplogistic').addClass('active');
			$('#delivery_door_eshoplogistic, #delivery_postrf_eshoplogistic').removeClass('active');
			if (!$('#delivery_terminal_eshoplogistic_selected').html().length) {
				first_terminal = json_terminals_eshoplogistic[0];
				
				$.cookie('eshoplogistic_terminal_code', first_terminal.code);
				$.cookie('delivery_service_eshoplogistic', first_terminal.service);
				$.cookie('eshoplogistic_city_code', eshoplogistic_get_city_code(first_terminal.service));
				
				eshoplogistic_terminal_desc = generate_delivery_terminal_item_eshoplogistic(first_terminal);
				
				$.cookie('eshoplogistic_terminal_desc', eshoplogistic_terminal_desc);
				$('#delivery_terminal_eshoplogistic_selected').html(eshoplogistic_terminal_desc);
				
				$(':radio.radio_virtuemart_shipmentmethod_eshoplogistic').click();
			}
		} else if ($(this).val() == 'postrf') {
			$('#delivery_postrf_eshoplogistic').addClass('active');
			$('#delivery_door_eshoplogistic, #delivery_terminal_eshoplogistic').removeClass('active');
			
			$.cookie('eshoplogistic_terminal_code', 'postrf');
			$.cookie('delivery_type_eshoplogistic', 'postrf');
			$.cookie('delivery_service_eshoplogistic', 'postrf');
			city_code = eshoplogistic_get_city_code('postrf');
			$.cookie('eshoplogistic_city_code', city_code);
			
			$(':radio.radio_virtuemart_shipmentmethod_eshoplogistic').trigger('click');
		}
	});
	
	$(document).on('click', 'div.delivery_door_item_eshoplogistic', function(){
		service = $(this).data('service');
		$.cookie('delivery_service_eshoplogistic', service);
		$.cookie('eshoplogistic_terminal_code', 'door');
		city_code = eshoplogistic_get_city_code(service);
		$.cookie('eshoplogistic_city_code', city_code);
		
		$('div.delivery_door_item_eshoplogistic').removeClass('active');
		$(this).addClass('active');
		$(':radio.radio_virtuemart_shipmentmethod_eshoplogistic').trigger('click');
	});
	
	//VPOPC
	$(document).on('vpopc.event', function(event, data){
		if (data == 'checkout.paymentselection.successs') {
			ProOPC.getshipmentpaymentcartlist();
		}
	});
});


function eshoplogistic_get_city_code(service) {
	str_codes = jQuery.cookie('eshoplogistic_city_codes').split('|');
	array_codes = {};
	jQuery(str_codes).each(function(){
		row = this.split('=');
		array_codes[row[0]] = row[1];
	});
	return array_codes[service];
}
